//
// Created by steven on 11/14/2024.
//

//#include <time.h>
//#include <stdlib.h>
#include "libs/include/SDL2/SDL.h"
#include <stdio.h>
//#include "libs/EPD_2in13_V4.h"
//#include "libs/GUI/GUI_Paint.h"
//#include "libs/GUI/GUI_BMPfile.h"

__declspec(dllexport) SDL_Window* createWindow() {
    SDL_Window *win = SDL_CreateWindow("Hello SDL",
                                       SDL_WINDOWPOS_CENTERED,
                                       SDL_WINDOWPOS_CENTERED,
                                       250, 122, SDL_WINDOW_SHOWN);
    if (!win) {
        printf("SDL_CreateWindow Error: %s\n", SDL_GetError());
        SDL_Quit();
        return NULL;
    }
    return win;
}

__declspec(dllexport) SDL_Renderer* createRenderer(SDL_Window *win) {
    SDL_Renderer *ren = SDL_CreateRenderer(win, -1, SDL_RENDERER_ACCELERATED | SDL_RENDERER_PRESENTVSYNC);
    if (!ren) {
        SDL_DestroyWindow(win);
        printf("SDL_CreateRenderer Error: %s\n", SDL_GetError());
        SDL_Quit();
        return NULL;
    }
    return ren;
}

__declspec(dllexport) int draw(SDL_Renderer *ren) {
    SDL_SetRenderDrawColor(ren, 255, 255, 255, 255);
    SDL_RenderClear(ren);

    SDL_SetRenderDrawColor(ren, 0, 0, 0, 255);
    SDL_RenderDrawLine(ren, 10, 10, 240, 112);
    SDL_RenderDrawLine(ren, 240, 10, 10, 112);
    SDL_RenderPresent(ren);

    return 0;
}

__declspec(dllexport) int destroy(SDL_Renderer *ren, SDL_Window *win) {
    if (!ren) {
        SDL_DestroyRenderer(ren);
    }
    if (!win) {
        SDL_DestroyWindow(win);
    }
}
